
/*******************************************************************************
*
* File time2.c
*
* Copyright (C) 2005 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Timing of spin2mat
*
*******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "random.h"
#include "su3.h"
#include "start.h"
#include "hmc.h"

#define N 2000000


int main(void)
{
   int count;
   double t1,t2,dt;
   su3_dble *u;
   spinor_dble *rx,*ry,*sx,*sy;
   
   printf("\n");
   printf("Timing of spin2mat\n");
   printf("------------------\n\n");

   u=amalloc(sizeof(su3_dble),4);
   rx=amalloc(sizeof(spinor_dble),4);
   error((u==NULL)||(rx==NULL),1,
         "main [time2.c]","Unable to allocate auxiliary arrays");

   ry=rx+1;
   sx=rx+2;
   sy=rx+3;
   
   rlxd_init(1,23456);
   ranlxd((double*)(rx),96);
   
   t1=(double)clock();
   for (count=0;count<N;count++)
   {
      spin2mat[0](rx,ry,sx,sy,u);
      spin2mat[1](rx,ry,sx,sy,u);
      spin2mat[2](rx,ry,sx,sy,u);
      spin2mat[3](rx,ry,sx,sy,u);
   }
   t2=(double)clock();

   dt=(t2-t1)/(double)(CLOCKS_PER_SEC);
   dt*=1.0e6/(double)(N);

   printf("The time per lattice point is %4.3f micro sec (%d Mflops)\n\n",
          dt,(int)(1272.0/dt));
   exit(0);
}
