
/*******************************************************************************
*
* File nompi/extras.h
*
* Copyright (C) 2005 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef EXTRAS_H 
#define EXTRAS_H

#ifndef BESSEL_C
extern float bessi0(float x);
extern float bessi1(float x);
extern float bessi(int n,float x);
extern float bessk0(float x);
extern float bessk1(float x);
extern float bessk(int n,float x);
#endif

#ifndef CHEBYSHEV_C
extern int cheby_fit(double a,double b,double (*f)(double x),
                     int dmax,double eps,double c[]);
extern double cheby_int(double a,double b,double (*f)(double x),
                        int dmax,double eps);
extern double cheby_val(double a,double b,int n,double c[],double x);
#endif

#ifndef KS_TEST_C
extern void ks_test(int n,double f[],double *pkp,double *pkm);
extern void ks_prob(int n,double kp,double km,double *pp,double *pm);
#endif

#ifndef PCHI_SQUARE_C
extern double pchi_square(double chi_square,int nu);
#endif

#ifndef STAT_C
extern double average(int n,double *a);
extern double sigma0(int n,double *a);
extern double auto_corr(int n,double *a,int tmax,double *g);
extern void sigma_auto_corr(int n,double *a,int tmax,int lambda,double *eg);
extern double tauint(int n,double *a,int tmax,int lambda,int *w,double *sigma);
extern double print_auto(int n,double *a);
extern double jack_err(int nx,int n,double **a,double (*f)(int nx,double *x),
                       int bmax,double *sig);
extern double print_jack(int nx,int n,double **a,double (*f)(int nx,double *x));
#endif

#endif
